/*
 * rsort.c
 * Client side application which sorts strings starting at argv[2].
 */

#include <stdio.h>
#include <rpc/rpc.h>
#include <tcp.h>
#include "sort.h"

int main (int argc, char **argv)
{
  char  *host_name;
  struct sortstrings args, res;
  int    i, status;

  if (argc < 3)
  {
    fprintf (stderr, "usage: %s host [str1 str2 ...]\n", argv[0]);
    return (1);
  }

#ifdef DEBUG
  dbug_init();
#endif
  rpc_init();
  sock_init();

  host_name      = argv[1];
  args.ss.ss_len = argc - 2; /* substract off progname, host */
  args.ss.ss_val = &argv[2];
  res.ss.ss_val  = NULL;

  status = callrpc (host_name, SORTPROG, SORTVERS, SORT,
                    xdr_sortstrings, (char*)&args,
                    xdr_sortstrings, (char*)&res);
  if (status)
  {
    clnt_perrno (status);
    return (1);
  }

  for (i = 0; i < res.ss.ss_len; i++)
      printf ("%s\n", res.ss.ss_val[i]);

  return (0);
}

