/*
 * This is a RPCGEN generated file. Do not edit.
 *
 * Generated: Wed Jun 26 20:32:56 2002
 */

#ifndef __NFS_PROT_H
#define __NFS_PROT_H

#define NFS_PORT                  2049
#define NFS_MAXDATA               8192
#define NFS_MAXPATHLEN            1024
#define NFS_MAXNAMLEN             255
#define NFS_FHSIZE                32
#define NFS_COOKIESIZE            4
#define NFS_FIFO_DEV              -1
#define NFSMODE_FMT               0170000
#define NFSMODE_DIR               0040000
#define NFSMODE_CHR               0020000
#define NFSMODE_BLK               0060000
#define NFSMODE_REG               0100000
#define NFSMODE_LNK               0120000
#define NFSMODE_SOCK              0140000
#define NFSMODE_FIFO              0010000

typedef enum nfsstat {
          NFS_OK = 0,
          NFSERR_PERM = 1,
          NFSERR_NOENT = 2,
          NFSERR_IO = 5,
          NFSERR_NXIO = 6,
          NFSERR_ACCES = 13,
          NFSERR_EXIST = 17,
          NFSERR_NODEV = 19,
          NFSERR_NOTDIR = 20,
          NFSERR_ISDIR = 21,
          NFSERR_FBIG = 27,
          NFSERR_NOSPC = 28,
          NFSERR_ROFS = 30,
          NFSERR_NAMETOOLONG = 63,
          NFSERR_NOTEMPTY = 66,
          NFSERR_DQUOT = 69,
          NFSERR_STALE = 70,
          NFSERR_WFLUSH = 99,
      } nfsstat;
bool_t xdr_nfsstat();


typedef enum ftype {
          NFNON = 0,
          NFREG = 1,
          NFDIR = 2,
          NFBLK = 3,
          NFCHR = 4,
          NFLNK = 5,
          NFSOCK = 6,
          NFBAD = 7,
          NFFIFO = 8,
      } ftype;
bool_t xdr_ftype();


typedef struct nfs_fh {
        char data[NFS_FHSIZE];
      } nfs_fh;
bool_t xdr_nfs_fh();


typedef struct nfstime {
        u_long seconds;
        u_long useconds;
      } nfstime;
bool_t xdr_nfstime();


typedef struct fattr {
        ftype type;
        u_long mode;
        u_long nlink;
        u_long uid;
        u_long gid;
        u_long size;
        u_long blocksize;
        u_long rdev;
        u_long blocks;
        u_long fsid;
        u_long fileid;
        nfstime atime;
        nfstime mtime;
        nfstime ctime;
      } fattr;
bool_t xdr_fattr();


typedef struct sattr {
        u_long mode;
        u_long uid;
        u_long gid;
        u_long size;
        nfstime atime;
        nfstime mtime;
      } sattr;
bool_t xdr_sattr();


typedef char *filename;
bool_t xdr_filename();


typedef char *nfspath;
bool_t xdr_nfspath();


typedef struct attrstat {
        nfsstat status;
  union {
    fattr attributes;
    } attrstat_u;
  } attrstat;
bool_t xdr_attrstat();


typedef struct sattrargs {
        nfs_fh file;
        sattr attributes;
      } sattrargs;
bool_t xdr_sattrargs();


typedef struct diropargs {
        nfs_fh dir;
        filename name;
      } diropargs;
bool_t xdr_diropargs();


typedef struct diropokres {
        nfs_fh file;
        fattr attributes;
      } diropokres;
bool_t xdr_diropokres();


typedef struct diropres {
        nfsstat status;
  union {
    diropokres diropres;
    } diropres_u;
  } diropres;
bool_t xdr_diropres();


typedef struct readlinkres {
        nfsstat status;
  union {
    nfspath data;
    } readlinkres_u;
  } readlinkres;
bool_t xdr_readlinkres();


typedef struct readargs {
        nfs_fh file;
        u_long offset;
        u_long count;
        u_long totalcount;
      } readargs;
bool_t xdr_readargs();


typedef struct readokres {
        fattr attributes;
        struct {
          u_long data_len;
          char *data_val;
        } data;
      } readokres;
bool_t xdr_readokres();


typedef struct readres {
        nfsstat status;
  union {
    readokres reply;
    } readres_u;
  } readres;
bool_t xdr_readres();


typedef struct writeargs {
        nfs_fh file;
        u_long beginoffset;
        u_long offset;
        u_long totalcount;
        struct {
          u_long data_len;
          char *data_val;
        } data;
      } writeargs;
bool_t xdr_writeargs();


typedef struct createargs {
        diropargs where;
        sattr attributes;
      } createargs;
bool_t xdr_createargs();


typedef struct renameargs {
        diropargs from;
        diropargs to;
      } renameargs;
bool_t xdr_renameargs();


typedef struct linkargs {
        nfs_fh from;
        diropargs to;
      } linkargs;
bool_t xdr_linkargs();


typedef struct symlinkargs {
        diropargs from;
        nfspath to;
        sattr attributes;
      } symlinkargs;
bool_t xdr_symlinkargs();


typedef char nfscookie[NFS_COOKIESIZE];
bool_t xdr_nfscookie();


typedef struct readdirargs {
        nfs_fh dir;
        nfscookie cookie;
        u_long count;
      } readdirargs;
bool_t xdr_readdirargs();


typedef struct entry {
        u_long fileid;
        filename name;
        nfscookie cookie;
        struct entry *nextentry;
      } entry;
bool_t xdr_entry();


typedef struct dirlist {
        entry *entries;
        bool_t eof;
      } dirlist;
bool_t xdr_dirlist();


typedef struct readdirres {
        nfsstat status;
  union {
    dirlist reply;
    } readdirres_u;
  } readdirres;
bool_t xdr_readdirres();


typedef struct statfsokres {
        u_long tsize;
        u_long bsize;
        u_long blocks;
        u_long bfree;
        u_long bavail;
      } statfsokres;
bool_t xdr_statfsokres();


typedef struct statfsres {
        nfsstat status;
  union {
    statfsokres reply;
    } statfsres_u;
  } statfsres;
bool_t xdr_statfsres();


#define NFS_PROGRAM               100003UL
#define NFS_VERSION               2UL
#define NFSPROC_NULL              0UL
extern void *nfsproc_null_2();

#define NFSPROC_GETATTR           1UL
extern attrstat *nfsproc_getattr_2();

#define NFSPROC_SETATTR           2UL
extern attrstat *nfsproc_setattr_2();

#define NFSPROC_ROOT              3UL
extern void *nfsproc_root_2();

#define NFSPROC_LOOKUP            4UL
extern diropres *nfsproc_lookup_2();

#define NFSPROC_READLINK          5UL
extern readlinkres *nfsproc_readlink_2();

#define NFSPROC_READ              6UL
extern readres *nfsproc_read_2();

#define NFSPROC_WRITECACHE        7UL
extern void *nfsproc_writecache_2();

#define NFSPROC_WRITE             8UL
extern attrstat *nfsproc_write_2();

#define NFSPROC_CREATE            9UL
extern diropres *nfsproc_create_2();

#define NFSPROC_REMOVE            10UL
extern nfsstat *nfsproc_remove_2();

#define NFSPROC_RENAME            11UL
extern nfsstat *nfsproc_rename_2();

#define NFSPROC_LINK              12UL
extern nfsstat *nfsproc_link_2();

#define NFSPROC_SYMLINK           13UL
extern nfsstat *nfsproc_symlink_2();

#define NFSPROC_MKDIR             14UL
extern diropres *nfsproc_mkdir_2();

#define NFSPROC_RMDIR             15UL
extern nfsstat *nfsproc_rmdir_2();

#define NFSPROC_READDIR           16UL
extern readdirres *nfsproc_readdir_2();

#define NFSPROC_STATFS            17UL
extern statfsres *nfsproc_statfs_2();


#endif /* !__NFS_PROT_H */
