#
# WatTCP RPC-library, Metaware HighC version.
#
# This is part of an MS-DOS port of SunRPC 4.0
#     mdurkin@tsoft.net, mdurkin@galaxy.calpoly.edu
#
# Updated by G. Vanem <giva@bgnett.no>
#
# Supported targets:
#   Metaware HighC 3.1+  protected mode, Pharlap 386|DosX
#
# Copyright (c) 1987 by Sun Microsystems, Inc.
#

!include ..\common.mak

.AUTODEPEND
.SWAP

HC_OBJS = $(LIB_SRC:.c=.o32)

all:     $(HC_RPCLIB)
         @echo Library $(BC_RPCLIB) done.

.c.o32:
        $(HC_CC) -c @&&|
         $(HC_CFLAGS)
| {$*.c }


$(HC_RPCLIB): $(HC_OBJS)
         386lib $< @&&|
           -nowarn -nobackup -twocase -replace $(HC_OBJS)
|

#
# Rules for generating the key protocol handler
#
key_prot.c key_prot.h: key_prot.x
        $(RPC_GEN) key_prot.x

clean:
   @del *.o32
   @del key_prot.c
   @del key_prot.h

#
# Dependencies
#              
key_call.c  : key_prot.h
pub_key.c   : key_prot.h

authunip.o32: authunip.c
auth_des.o32: auth_des.c
auth_non.o32: auth_non.c
auth_uni.o32: auth_uni.c
bindresv.o32: bindresv.c
cache.o32   : cache.c
clnt_gen.o32: clnt_gen.c
clnt_per.o32: clnt_per.c
clnt_raw.o32: clnt_raw.c
clnt_sim.o32: clnt_sim.c
clnt_tcp.o32: clnt_tcp.c
clnt_udp.o32: clnt_udp.c
config.o32  : config.c
des_cryp.o32: des_cryp.c
des_soft.o32: des_soft.c
getrpc.o32  : getrpc.c
get_myad.o32: get_myad.c
key_call.o32: key_call.c
key_prot.o32: key_prot.c
netname.o32 : netname.c
openchil.o32: openchil.c
pmap_cln.o32: pmap_cln.c
pmap_get.o32: pmap_get.c
pmap_gp.o32 : pmap_gp.c
pmap_p2.o32 : pmap_p2.c
pmap_pro.o32: pmap_pro.c
pmap_rmt.o32: pmap_rmt.c
pub_key.o32 : pub_key.c
rpc_cmnd.o32: rpc_cmnd.c
rpc_cmsg.o32: rpc_cmsg.c
rpc_dtsz.o32: rpc_dtsz.c
rpc_prot.o32: rpc_prot.c
rtime.o32   : rtime.c
svc.o32     : svc.c
svc_auth.o32: svc_auth.c
svc_des.o32 : svc_des.c
svc_raw.o32 : svc_raw.c
svc_run.o32 : svc_run.c
svc_simp.o32: svc_simp.c
svc_tcp.o32 : svc_tcp.c
svc_udp.o32 : svc_udp.c
unixuid.o32 : unixuid.c
xcrypt.o32  : xcrypt.c
xdr.o32     : xdr.c
xdr_arry.o32: xdr_arry.c
xdr_floa.o32: xdr_floa.c
xdr_mem.o32 : xdr_mem.c
xdr_rec.o32 : xdr_rec.c
xdr_ref.o32 : xdr_ref.c
xdr_stio.o32: xdr_stio.c

